// #autoload
// #name = Include Grab Speed
// #version = 1.1
// #date = January 19th, 2003
// #author = include
// #warrior = include
// #email = include@nullmind.net
// #web = http://www.nullmind.net
// #description = Flashes red text and grab speed when you have the flag.  Plays sound when you die/cap as well
// #category = Include

if (!isObject(IncGotFlag))
{
  new ScriptObject(IncGotFlag)
  {
    class = IncGotFlag;
  };
}

if(isFile("prefs/IncPackPrefs.cs"))
{
  exec("prefs/IncPackPrefs.cs");
  error("Using existing IncPack Prefs...");
}
else
{
  $IncPackPrefs::GrabSpeedText1 = "Stupid Gay Route ";
  $IncPackPrefs::GrabSpeedText2 = "Stupid Flagstand ";
  $IncPackPrefs::GrabSpeedText3 = "See Ya!!! ";
  $IncPackPrefs::GrabSpeedText4 = "Holy SHIT ";
  $IncPackPrefs::GrabSpeedText5 = "Watch for OOB speedy ";
  error("Creating IncPack Prefs...");
}

function TauntJason()
{
  alxPlay(alxCreateSource(AudioChat, "tauntjason.wav"));
}

function IncGotFlagJoin(%msgType, %msgString, %clientName, %clientId, %targetId, %isAI, %isAdmin, %isSuperAdmin, %isSmurf, %guid)
{
  if(StrStr(%msgString, "Welcome to Tribes") != -1)
    $IncName = detag(%clientName);
}

function IncGotFlagFlagTakenHandler(%msgType, %msgString, %clientName, %a2, %a3, %a4)
{
  %clientName = detag(%clientName);
    if ($IncName $= %clientName)
    {
      %speed = mFloor(getControlObjectSpeed() * 3.6);

      if (%speed < 76)
      {
        IncGotFlag.text = "<just:center>" @ $IncPackPrefs::GrabSpeedText1 @ %speed @ "KPH";
        alxPlay(alxCreateSource(AudioChat, "slowcap.wav"));
          if (Strstr($IncName, "Futant") != -1)
          {
            $JasonIsSlow = schedule(10000, 0, TauntJason);
          }
      }
      else if (%speed < 151)
      {
        IncGotFlag.text = "<just:center>" @ $IncPackPrefs::GrabSpeedText2 @ %speed @ "KPH";
        alxPlay(alxCreateSource(AudioChat, "medcap.wav"));
      }
      else if (%speed < 251)
      {
        IncGotFlag.text = "<just:center>" @ $IncPackPrefs::GrabSpeedText3 @ %speed @ "KPH";
        alxPlay(alxCreateSource(AudioChat, "fastcap.wav"));
      }
      else if (%speed < 400)
      {
        IncGotFlag.text = "<just:center>" @ $IncPackPrefs::GrabSpeedText4 @ %speed @ "KPH";
        alxPlay(alxCreateSource(AudioChat, "byebyecap.wav"));
      }
      else
      {
        IncGotFlag.text = "<just:center>" @ $IncPackPrefs::GrabSpeedText5 ;
      }
    IncGotFlag.show();
    }
}

function IncGotFlagFlagLostHandler(%msgType, %msgString, %clientName, %a2, %teamid, %a4)
{
  %clientName = detag(%clientName);
  if ($IncName $= %clientName)
  {
    IncGotFlagHudHide();
    alxPlay(alxCreateSource(AudioChat, "voice/Announcer/ANN.holdflags.WAV"));
  }
  cancel($JasonIsSlow);
}

function IncGotFlagFlagCappedHandler(%msgType, %msgString, %clientName, %a2, %teamid, %a4)
{
  %clientName = detag(%clientName);
  if ($IncName $= %clientName)
  {
    IncGotFlagHudHide();
    alxPlay(alxCreateSource(AudioChat, "ohyeah.wav"));
  }
  cancel($JasonIsSlow);
}

function IncGotFlag::show(%this)
{
  %x = (getWord($pref::Video::resolution, 0) - 177)/2;
  %y = getWord(retCenterHud.position, 1) + (IncGotFlag.tr2 ? 250 : 190);

  if (!isObject(IncGotFlagHud))
  {
    IncGotFlag.textProfile = new GuiControlProfile()
    {
     fontType = $ShellLabelFont;
      fontSize = 22;
      fontColor = "220 0 0";
      justify = "center";
      autoSizeWidth = true;
      autoSizeHeight = true;
    };
      new ShellFieldCtrl(IncGotFlagHud)
      {
        profile = "GuiConsoleProfile";
        horizSizing = "center";
        vertSizing = "top";
        position = %x SPC %y;
        extent = "177 25";
        minExtent = "16 18";
        visible = "0";
        hideCursor = "0";
        bypassHideCursor = "0";
        helpTag = "0";

          new GuiMLTextCtrl(IncGotFlagHudText)
          {
            profile = IncGotFlag.textProfile;
            horizSizing = "width";
            vertSizing = "top";
            position = "0 0";
            extent = "177 25";
            minExtent = "8 8";
            visible = "1";
            hideCursor = "0";
            bypassHideCursor = "0";
            helpTag = "0";
            text = "";
            longTextBuffer = "0";
            maxLength = "255";
          };
      };

    PlayGui.add(IncGotFlagHud);
    IncGotFlagHud.setPosition(%x,%y);
	}

  IncGotFlagHud.setPosition(%x,%y);
  IncGotFlagHudText.setPosition(0,0);
  IncGotFlagHud.setVisible(true);
  IncGotFlag.blink();
}

function IncGotFlagHudHide()
{
  if (isObject(IncGotFlagHud)) IncGotFlagHud.setVisible(false);
}

function IncGotFlag::blink(%this)
{
  %this.textProfileID = !%this.textProfileID;
  if (%this.textProfileID) %color = "<color:DC0000>";
  else %color = "<color:FFDCDC>";

  IncGotFlagHudText.setValue(%color @ %this.text);

  if (isEventPending(%this.schedID)) cancel(%this.schedID);
  if (IncGotFlagHud.visible) IncGotFlag.schedID = %this.schedule(400,"blink");
}

package IncGotFlagPkg
{

function OptionsDlg::onWake(%this)
{
  parent::onWake(%this);
}

};

addMessageCallback('MsgClientJoin', IncGotFlagJoin);
addMessageCallback('MsgCTFFlagTaken',IncGotFlagFlagTakenHandler);
addMessageCallback('MsgCTFFlagDropped',IncGotFlagFlagLostHandler);
addMessageCallback('MsgCTFFlagCapped',IncGotFlagFlagCappedHandler);
addMessageCallback('MsgMissionDropInfo',IncGotFlagHudHide);
addMessageCallback('MsgTR2FlagTaken',IncGotFlagFlagTakenHandler);
addMessageCallback('MsgTR2FlagDropped',IncGotFlagFlagLostHandler);
addMessageCallback('MsgTR2ForcedRespawn',IncGotFlagFlagLostHandler);
addMessageCallback('MsgTR2TeamScored',IncGotFlagFlagLostHandler);

activatePackage(IncGotFlag);
